package com.lightinit.hsdataportal.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class DataCatelogItemExample extends BaseExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public DataCatelogItemExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andDataCatelogIdIsNull() {
            addCriterion("data_catelog_id is null");
            return (Criteria) this;
        }

        public Criteria andDataCatelogIdIsNotNull() {
            addCriterion("data_catelog_id is not null");
            return (Criteria) this;
        }

        public Criteria andDataCatelogIdEqualTo(Long value) {
            addCriterion("data_catelog_id =", value, "dataCatelogId");
            return (Criteria) this;
        }

        public Criteria andDataCatelogIdNotEqualTo(Long value) {
            addCriterion("data_catelog_id <>", value, "dataCatelogId");
            return (Criteria) this;
        }

        public Criteria andDataCatelogIdGreaterThan(Long value) {
            addCriterion("data_catelog_id >", value, "dataCatelogId");
            return (Criteria) this;
        }

        public Criteria andDataCatelogIdGreaterThanOrEqualTo(Long value) {
            addCriterion("data_catelog_id >=", value, "dataCatelogId");
            return (Criteria) this;
        }

        public Criteria andDataCatelogIdLessThan(Long value) {
            addCriterion("data_catelog_id <", value, "dataCatelogId");
            return (Criteria) this;
        }

        public Criteria andDataCatelogIdLessThanOrEqualTo(Long value) {
            addCriterion("data_catelog_id <=", value, "dataCatelogId");
            return (Criteria) this;
        }

        public Criteria andDataCatelogIdIn(List<Long> values) {
            addCriterion("data_catelog_id in", values, "dataCatelogId");
            return (Criteria) this;
        }

        public Criteria andDataCatelogIdNotIn(List<Long> values) {
            addCriterion("data_catelog_id not in", values, "dataCatelogId");
            return (Criteria) this;
        }

        public Criteria andDataCatelogIdBetween(Long value1, Long value2) {
            addCriterion("data_catelog_id between", value1, value2, "dataCatelogId");
            return (Criteria) this;
        }

        public Criteria andDataCatelogIdNotBetween(Long value1, Long value2) {
            addCriterion("data_catelog_id not between", value1, value2, "dataCatelogId");
            return (Criteria) this;
        }

        public Criteria andItemNameIsNull() {
            addCriterion("item_name is null");
            return (Criteria) this;
        }

        public Criteria andItemNameIsNotNull() {
            addCriterion("item_name is not null");
            return (Criteria) this;
        }

        public Criteria andItemNameEqualTo(String value) {
            addCriterion("item_name =", value, "itemName");
            return (Criteria) this;
        }

        public Criteria andItemNameNotEqualTo(String value) {
            addCriterion("item_name <>", value, "itemName");
            return (Criteria) this;
        }

        public Criteria andItemNameGreaterThan(String value) {
            addCriterion("item_name >", value, "itemName");
            return (Criteria) this;
        }

        public Criteria andItemNameGreaterThanOrEqualTo(String value) {
            addCriterion("item_name >=", value, "itemName");
            return (Criteria) this;
        }

        public Criteria andItemNameLessThan(String value) {
            addCriterion("item_name <", value, "itemName");
            return (Criteria) this;
        }

        public Criteria andItemNameLessThanOrEqualTo(String value) {
            addCriterion("item_name <=", value, "itemName");
            return (Criteria) this;
        }

        public Criteria andItemNameLike(String value) {
            addCriterion("item_name like", value, "itemName");
            return (Criteria) this;
        }

        public Criteria andItemNameNotLike(String value) {
            addCriterion("item_name not like", value, "itemName");
            return (Criteria) this;
        }

        public Criteria andItemNameIn(List<String> values) {
            addCriterion("item_name in", values, "itemName");
            return (Criteria) this;
        }

        public Criteria andItemNameNotIn(List<String> values) {
            addCriterion("item_name not in", values, "itemName");
            return (Criteria) this;
        }

        public Criteria andItemNameBetween(String value1, String value2) {
            addCriterion("item_name between", value1, value2, "itemName");
            return (Criteria) this;
        }

        public Criteria andItemNameNotBetween(String value1, String value2) {
            addCriterion("item_name not between", value1, value2, "itemName");
            return (Criteria) this;
        }

        public Criteria andItemTypeIsNull() {
            addCriterion("item_type is null");
            return (Criteria) this;
        }

        public Criteria andItemTypeIsNotNull() {
            addCriterion("item_type is not null");
            return (Criteria) this;
        }

        public Criteria andItemTypeEqualTo(String value) {
            addCriterion("item_type =", value, "itemType");
            return (Criteria) this;
        }

        public Criteria andItemTypeNotEqualTo(String value) {
            addCriterion("item_type <>", value, "itemType");
            return (Criteria) this;
        }

        public Criteria andItemTypeGreaterThan(String value) {
            addCriterion("item_type >", value, "itemType");
            return (Criteria) this;
        }

        public Criteria andItemTypeGreaterThanOrEqualTo(String value) {
            addCriterion("item_type >=", value, "itemType");
            return (Criteria) this;
        }

        public Criteria andItemTypeLessThan(String value) {
            addCriterion("item_type <", value, "itemType");
            return (Criteria) this;
        }

        public Criteria andItemTypeLessThanOrEqualTo(String value) {
            addCriterion("item_type <=", value, "itemType");
            return (Criteria) this;
        }

        public Criteria andItemTypeLike(String value) {
            addCriterion("item_type like", value, "itemType");
            return (Criteria) this;
        }

        public Criteria andItemTypeNotLike(String value) {
            addCriterion("item_type not like", value, "itemType");
            return (Criteria) this;
        }

        public Criteria andItemTypeIn(List<String> values) {
            addCriterion("item_type in", values, "itemType");
            return (Criteria) this;
        }

        public Criteria andItemTypeNotIn(List<String> values) {
            addCriterion("item_type not in", values, "itemType");
            return (Criteria) this;
        }

        public Criteria andItemTypeBetween(String value1, String value2) {
            addCriterion("item_type between", value1, value2, "itemType");
            return (Criteria) this;
        }

        public Criteria andItemTypeNotBetween(String value1, String value2) {
            addCriterion("item_type not between", value1, value2, "itemType");
            return (Criteria) this;
        }

        public Criteria andItemLengthIsNull() {
            addCriterion("item_length is null");
            return (Criteria) this;
        }

        public Criteria andItemLengthIsNotNull() {
            addCriterion("item_length is not null");
            return (Criteria) this;
        }

        public Criteria andItemLengthEqualTo(String value) {
            addCriterion("item_length =", value, "itemLength");
            return (Criteria) this;
        }

        public Criteria andItemLengthNotEqualTo(String value) {
            addCriterion("item_length <>", value, "itemLength");
            return (Criteria) this;
        }

        public Criteria andItemLengthGreaterThan(String value) {
            addCriterion("item_length >", value, "itemLength");
            return (Criteria) this;
        }

        public Criteria andItemLengthGreaterThanOrEqualTo(String value) {
            addCriterion("item_length >=", value, "itemLength");
            return (Criteria) this;
        }

        public Criteria andItemLengthLessThan(String value) {
            addCriterion("item_length <", value, "itemLength");
            return (Criteria) this;
        }

        public Criteria andItemLengthLessThanOrEqualTo(String value) {
            addCriterion("item_length <=", value, "itemLength");
            return (Criteria) this;
        }

        public Criteria andItemLengthLike(String value) {
            addCriterion("item_length like", value, "itemLength");
            return (Criteria) this;
        }

        public Criteria andItemLengthNotLike(String value) {
            addCriterion("item_length not like", value, "itemLength");
            return (Criteria) this;
        }

        public Criteria andItemLengthIn(List<String> values) {
            addCriterion("item_length in", values, "itemLength");
            return (Criteria) this;
        }

        public Criteria andItemLengthNotIn(List<String> values) {
            addCriterion("item_length not in", values, "itemLength");
            return (Criteria) this;
        }

        public Criteria andItemLengthBetween(String value1, String value2) {
            addCriterion("item_length between", value1, value2, "itemLength");
            return (Criteria) this;
        }

        public Criteria andItemLengthNotBetween(String value1, String value2) {
            addCriterion("item_length not between", value1, value2, "itemLength");
            return (Criteria) this;
        }

        public Criteria andShareTypeIsNull() {
            addCriterion("share_type is null");
            return (Criteria) this;
        }

        public Criteria andShareTypeIsNotNull() {
            addCriterion("share_type is not null");
            return (Criteria) this;
        }

        public Criteria andShareTypeEqualTo(String value) {
            addCriterion("share_type =", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeNotEqualTo(String value) {
            addCriterion("share_type <>", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeGreaterThan(String value) {
            addCriterion("share_type >", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeGreaterThanOrEqualTo(String value) {
            addCriterion("share_type >=", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeLessThan(String value) {
            addCriterion("share_type <", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeLessThanOrEqualTo(String value) {
            addCriterion("share_type <=", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeLike(String value) {
            addCriterion("share_type like", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeNotLike(String value) {
            addCriterion("share_type not like", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeIn(List<String> values) {
            addCriterion("share_type in", values, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeNotIn(List<String> values) {
            addCriterion("share_type not in", values, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeBetween(String value1, String value2) {
            addCriterion("share_type between", value1, value2, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeNotBetween(String value1, String value2) {
            addCriterion("share_type not between", value1, value2, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareConditionIsNull() {
            addCriterion("share_condition is null");
            return (Criteria) this;
        }

        public Criteria andShareConditionIsNotNull() {
            addCriterion("share_condition is not null");
            return (Criteria) this;
        }

        public Criteria andShareConditionEqualTo(String value) {
            addCriterion("share_condition =", value, "shareCondition");
            return (Criteria) this;
        }

        public Criteria andShareConditionNotEqualTo(String value) {
            addCriterion("share_condition <>", value, "shareCondition");
            return (Criteria) this;
        }

        public Criteria andShareConditionGreaterThan(String value) {
            addCriterion("share_condition >", value, "shareCondition");
            return (Criteria) this;
        }

        public Criteria andShareConditionGreaterThanOrEqualTo(String value) {
            addCriterion("share_condition >=", value, "shareCondition");
            return (Criteria) this;
        }

        public Criteria andShareConditionLessThan(String value) {
            addCriterion("share_condition <", value, "shareCondition");
            return (Criteria) this;
        }

        public Criteria andShareConditionLessThanOrEqualTo(String value) {
            addCriterion("share_condition <=", value, "shareCondition");
            return (Criteria) this;
        }

        public Criteria andShareConditionLike(String value) {
            addCriterion("share_condition like", value, "shareCondition");
            return (Criteria) this;
        }

        public Criteria andShareConditionNotLike(String value) {
            addCriterion("share_condition not like", value, "shareCondition");
            return (Criteria) this;
        }

        public Criteria andShareConditionIn(List<String> values) {
            addCriterion("share_condition in", values, "shareCondition");
            return (Criteria) this;
        }

        public Criteria andShareConditionNotIn(List<String> values) {
            addCriterion("share_condition not in", values, "shareCondition");
            return (Criteria) this;
        }

        public Criteria andShareConditionBetween(String value1, String value2) {
            addCriterion("share_condition between", value1, value2, "shareCondition");
            return (Criteria) this;
        }

        public Criteria andShareConditionNotBetween(String value1, String value2) {
            addCriterion("share_condition not between", value1, value2, "shareCondition");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryIsNull() {
            addCriterion("share_method_category is null");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryIsNotNull() {
            addCriterion("share_method_category is not null");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryEqualTo(String value) {
            addCriterion("share_method_category =", value, "shareMethodCategory");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryNotEqualTo(String value) {
            addCriterion("share_method_category <>", value, "shareMethodCategory");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryGreaterThan(String value) {
            addCriterion("share_method_category >", value, "shareMethodCategory");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryGreaterThanOrEqualTo(String value) {
            addCriterion("share_method_category >=", value, "shareMethodCategory");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryLessThan(String value) {
            addCriterion("share_method_category <", value, "shareMethodCategory");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryLessThanOrEqualTo(String value) {
            addCriterion("share_method_category <=", value, "shareMethodCategory");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryLike(String value) {
            addCriterion("share_method_category like", value, "shareMethodCategory");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryNotLike(String value) {
            addCriterion("share_method_category not like", value, "shareMethodCategory");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryIn(List<String> values) {
            addCriterion("share_method_category in", values, "shareMethodCategory");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryNotIn(List<String> values) {
            addCriterion("share_method_category not in", values, "shareMethodCategory");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryBetween(String value1, String value2) {
            addCriterion("share_method_category between", value1, value2, "shareMethodCategory");
            return (Criteria) this;
        }

        public Criteria andShareMethodCategoryNotBetween(String value1, String value2) {
            addCriterion("share_method_category not between", value1, value2, "shareMethodCategory");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeIsNull() {
            addCriterion("share_method_type is null");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeIsNotNull() {
            addCriterion("share_method_type is not null");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeEqualTo(String value) {
            addCriterion("share_method_type =", value, "shareMethodType");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeNotEqualTo(String value) {
            addCriterion("share_method_type <>", value, "shareMethodType");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeGreaterThan(String value) {
            addCriterion("share_method_type >", value, "shareMethodType");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeGreaterThanOrEqualTo(String value) {
            addCriterion("share_method_type >=", value, "shareMethodType");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeLessThan(String value) {
            addCriterion("share_method_type <", value, "shareMethodType");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeLessThanOrEqualTo(String value) {
            addCriterion("share_method_type <=", value, "shareMethodType");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeLike(String value) {
            addCriterion("share_method_type like", value, "shareMethodType");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeNotLike(String value) {
            addCriterion("share_method_type not like", value, "shareMethodType");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeIn(List<String> values) {
            addCriterion("share_method_type in", values, "shareMethodType");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeNotIn(List<String> values) {
            addCriterion("share_method_type not in", values, "shareMethodType");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeBetween(String value1, String value2) {
            addCriterion("share_method_type between", value1, value2, "shareMethodType");
            return (Criteria) this;
        }

        public Criteria andShareMethodTypeNotBetween(String value1, String value2) {
            addCriterion("share_method_type not between", value1, value2, "shareMethodType");
            return (Criteria) this;
        }

        public Criteria andIsOpenIsNull() {
            addCriterion("is_open is null");
            return (Criteria) this;
        }

        public Criteria andIsOpenIsNotNull() {
            addCriterion("is_open is not null");
            return (Criteria) this;
        }

        public Criteria andIsOpenEqualTo(Byte value) {
            addCriterion("is_open =", value, "isOpen");
            return (Criteria) this;
        }

        public Criteria andIsOpenNotEqualTo(Byte value) {
            addCriterion("is_open <>", value, "isOpen");
            return (Criteria) this;
        }

        public Criteria andIsOpenGreaterThan(Byte value) {
            addCriterion("is_open >", value, "isOpen");
            return (Criteria) this;
        }

        public Criteria andIsOpenGreaterThanOrEqualTo(Byte value) {
            addCriterion("is_open >=", value, "isOpen");
            return (Criteria) this;
        }

        public Criteria andIsOpenLessThan(Byte value) {
            addCriterion("is_open <", value, "isOpen");
            return (Criteria) this;
        }

        public Criteria andIsOpenLessThanOrEqualTo(Byte value) {
            addCriterion("is_open <=", value, "isOpen");
            return (Criteria) this;
        }

        public Criteria andIsOpenIn(List<Byte> values) {
            addCriterion("is_open in", values, "isOpen");
            return (Criteria) this;
        }

        public Criteria andIsOpenNotIn(List<Byte> values) {
            addCriterion("is_open not in", values, "isOpen");
            return (Criteria) this;
        }

        public Criteria andIsOpenBetween(Byte value1, Byte value2) {
            addCriterion("is_open between", value1, value2, "isOpen");
            return (Criteria) this;
        }

        public Criteria andIsOpenNotBetween(Byte value1, Byte value2) {
            addCriterion("is_open not between", value1, value2, "isOpen");
            return (Criteria) this;
        }

        public Criteria andOpenConditionIsNull() {
            addCriterion("open_condition is null");
            return (Criteria) this;
        }

        public Criteria andOpenConditionIsNotNull() {
            addCriterion("open_condition is not null");
            return (Criteria) this;
        }

        public Criteria andOpenConditionEqualTo(String value) {
            addCriterion("open_condition =", value, "openCondition");
            return (Criteria) this;
        }

        public Criteria andOpenConditionNotEqualTo(String value) {
            addCriterion("open_condition <>", value, "openCondition");
            return (Criteria) this;
        }

        public Criteria andOpenConditionGreaterThan(String value) {
            addCriterion("open_condition >", value, "openCondition");
            return (Criteria) this;
        }

        public Criteria andOpenConditionGreaterThanOrEqualTo(String value) {
            addCriterion("open_condition >=", value, "openCondition");
            return (Criteria) this;
        }

        public Criteria andOpenConditionLessThan(String value) {
            addCriterion("open_condition <", value, "openCondition");
            return (Criteria) this;
        }

        public Criteria andOpenConditionLessThanOrEqualTo(String value) {
            addCriterion("open_condition <=", value, "openCondition");
            return (Criteria) this;
        }

        public Criteria andOpenConditionLike(String value) {
            addCriterion("open_condition like", value, "openCondition");
            return (Criteria) this;
        }

        public Criteria andOpenConditionNotLike(String value) {
            addCriterion("open_condition not like", value, "openCondition");
            return (Criteria) this;
        }

        public Criteria andOpenConditionIn(List<String> values) {
            addCriterion("open_condition in", values, "openCondition");
            return (Criteria) this;
        }

        public Criteria andOpenConditionNotIn(List<String> values) {
            addCriterion("open_condition not in", values, "openCondition");
            return (Criteria) this;
        }

        public Criteria andOpenConditionBetween(String value1, String value2) {
            addCriterion("open_condition between", value1, value2, "openCondition");
            return (Criteria) this;
        }

        public Criteria andOpenConditionNotBetween(String value1, String value2) {
            addCriterion("open_condition not between", value1, value2, "openCondition");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(Long value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(Long value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(Long value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(Long value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(Long value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(Long value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<Long> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<Long> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(Long value1, Long value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(Long value1, Long value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNull() {
            addCriterion("deleted_at is null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNotNull() {
            addCriterion("deleted_at is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtEqualTo(Date value) {
            addCriterion("deleted_at =", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotEqualTo(Date value) {
            addCriterion("deleted_at <>", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThan(Date value) {
            addCriterion("deleted_at >", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("deleted_at >=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThan(Date value) {
            addCriterion("deleted_at <", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThanOrEqualTo(Date value) {
            addCriterion("deleted_at <=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIn(List<Date> values) {
            addCriterion("deleted_at in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotIn(List<Date> values) {
            addCriterion("deleted_at not in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtBetween(Date value1, Date value2) {
            addCriterion("deleted_at between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotBetween(Date value1, Date value2) {
            addCriterion("deleted_at not between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNull() {
            addCriterion("deleted_by is null");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNotNull() {
            addCriterion("deleted_by is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedByEqualTo(Long value) {
            addCriterion("deleted_by =", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotEqualTo(Long value) {
            addCriterion("deleted_by <>", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThan(Long value) {
            addCriterion("deleted_by >", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThanOrEqualTo(Long value) {
            addCriterion("deleted_by >=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThan(Long value) {
            addCriterion("deleted_by <", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThanOrEqualTo(Long value) {
            addCriterion("deleted_by <=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByIn(List<Long> values) {
            addCriterion("deleted_by in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotIn(List<Long> values) {
            addCriterion("deleted_by not in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByBetween(Long value1, Long value2) {
            addCriterion("deleted_by between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotBetween(Long value1, Long value2) {
            addCriterion("deleted_by not between", value1, value2, "deletedBy");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}